﻿using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Diagnostics;
using System.Threading.Tasks;
using System.Windows.Forms;
using Microsoft.Win32;
using System.Threading;

namespace LGS___Sleep_Mode_Fix
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            SystemEvents.PowerModeChanged += SystemEvents_PowerModeChanged;
        }

        void SystemEvents_PowerModeChanged(object sender, PowerModeChangedEventArgs e)
        {
            if (e.Mode.ToString() == "Resume"){
                rebootApp();
            }
        }

        private void Form1_Load(object sender, System.EventArgs e)
        {
            this.Hide();

            RegistryKey rkApp = Registry.CurrentUser.OpenSubKey("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Run", true);

            //if app hasnt been launched yet
            if (rkApp.GetValue("LGS Keyboard Fix") == null)
            {
                rkApp.SetValue("LGS Keyboard Fix", Application.ExecutablePath.ToString());
            }

            //if app has moved
            if (rkApp.GetValue("LGS Keyboard Fix").ToString() != Application.ExecutablePath.ToString())
            {
                rkApp.SetValue("LGS Keyboard Fix", Application.ExecutablePath.ToString());
            }
        }

        private void Form1_Resize(object sender, System.EventArgs e)
        {
            if (FormWindowState.Minimized == this.WindowState)
            {
                this.Hide();
            }
        }

        private void notifyIcon1_MouseClick(object sender, MouseEventArgs e)
        {
            restoreWindow();
        }

        private void notifyIcon1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            restoreWindow();
        }

        private void restoreWindow()
        {
            this.Show();
            this.WindowState = FormWindowState.Normal;
        }

        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        { 
            this.linkLabel1.LinkVisited = true;
            System.Diagnostics.Process.Start("http://www.llamaco.ca");
        }

        private void rebootApp()
        {
            string filePath = "C:/Program Files/Logitech Gaming Software/LCore";
            foreach (var process in Process.GetProcessesByName("LCore"))
            {
                filePath = process.MainModule.FileName;
                process.Kill();
            }

            //wait for child applets to close
            Thread.Sleep(5000);

            //relaunch app
            ProcessStartInfo start = new ProcessStartInfo();
            start.Arguments = "/minimized";
            start.FileName = filePath;
            start.WindowStyle = ProcessWindowStyle.Hidden;
            start.CreateNoWindow = true;
            using (Process proc = Process.Start(start)) { }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            rebootApp();
        }
    }
}